# FOLF-ray

## Introduction

"FOLF-Ray" is a cross-platform software realtime raytracing game engine (under development) with an aesthetic that combines the old and the new. More details to follow as the engine is developed.

## Demo

FOLF-Ray comes packaged with a demo, but you can modify this project by moving the `res` folder next to the program binary so it compiles the project inside. See the included manual PDF for the developer's reference.

## Command line arguments

- `-benchmark #` Runs the FOLF-ray demo for `#` seconds, then closes the engine. The results are stored in `profile.csv`.
- `-spinup #` Waits `#` before starting the recording of the benchmark. `-benchmark` must be specified.
- `-threads #` Runs FOLF-ray with `#` threads for rendering the scene. You will likely not see an improvement beyond `8`.
- `-audio #` Sets the default audio device by index `#` (all detected audio devices and their indices are listed in the log at startup)

# LICENSE

Copyright (C) WOLFCODER WORKSHOP LLC 2023

```
THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES 
OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS 
BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF 
OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
```

## Art material

Original images in the resource folder `res` can be used under the CC BY 4.0 license. See CCBY40.txt for a copy of this license or go to https://creativecommons.org/licenses/by/4.0/ for more information. Some images were sourced from elsewhere and have their own licenses:

- "Partly Cloudy (Pure Sky)" (https://polyhaven.com/a/kloofendal_48d_partly_cloudy_puresky) CC0 license

## Sound effect sources

- "Glass Break" unfa (https://freesound.org/people/unfa/)
- "Energy Field Loop 4" unfa (https://freesound.org/people/unfa/)
- "UI Click" EminYILDIRIM (https://freesound.org/people/EminYILDIRIM/)
- "Best Hypnotic Wind Chimes ~ Long Nice Loop" DudeAwesome (https://freesound.org/people/DudeAwesome/)
- "Ice Block - Sliding, Crunching, Scraping" Percy Duke (https://freesound.org/people/Percy%20Duke/)
