// FOLF-Ray demo

local handle = 0;

// Makes a clicky noise when you press OK
function click()
{
	fr_sound_play_2d("click",PLAY_ONCE,1.0,1.0,0.0);
}
fr_input_react("click",INPUT_OK);

// Enter pointer mode with right click and exit with click
function open_menu()
{
	fr_input_pointer_mode("pointer");
}
fr_input_react("open_menu",INPUT_ALT_FIRE);
function close_menu()
{
	local who = fr_ent_create();
	local ply = fr_ent_get_by_name("player");
	local pos = fr_ent_get_position(ply);
	// fr_ent_set_position(who,pos);
	// fr_ent_morph_mesh(who,"brick","#cube");
	// fr_ent_set_behave(who,"tumble");
	fr_input_aim_mode();
}
fr_input_react("close_menu",INPUT_FIRE);

// The "player"
handle = fr_ent_create();
fr_ent_set_orientation(handle,[90.0,0.0,0.0]);
fr_ent_set_behave(handle,"walkthrough");
fr_ent_give_name(handle,"player");

// Configure scene
fr_render_set_ambient(fr_color_from_rgb(32,35,54));
fr_render_set_sun(fr_color_from_rgb(229,237,248));
fr_render_set_sun_direction([0.0,-1.0,1.0]);
fr_render_set_clear_color([0.2,0.2,0.2]);

// Make the background
function bricks(me)
{
	local w = fr_image_width("brickfade");
	local h = fr_image_height("brickfade");
	fr_draw_image("brickfade",0,0,0,0,w,h);
}
handle = fr_ent_create();
fr_ent_morph_draw(handle,DRAW_BACK);
fr_ent_set_behave(handle,"bricks");

// Label this thing as a demo (mostly just testing top layer drawing)
function demolabel(me)
{
	fr_draw_image_simple("demo",8,fr_draw_height()-16);
}
handle = fr_ent_create();
fr_ent_morph_draw(handle,DRAW_TOP);
fr_ent_set_behave(handle,"demolabel");

// Make container box
handle = fr_ent_create();
fr_ent_morph_mesh(handle,"brick","#cube");
fr_ent_set_scale(handle,8.0,1);
fr_ent_set_invert(handle,1);
fr_ent_set_position(handle,[0.0,0.0,7.0]);

// Make shiny box
handle = fr_ent_create();
fr_ent_morph_mesh(handle,"shiny","#cube");
fr_ent_set_position(handle,[-3.0,6.0,0.0]);

// Make glass box
handle = fr_ent_create();
fr_ent_morph_mesh(handle,"glass","#cube");
fr_ent_set_position(handle,[3.0,-4.5,1.0]);
fr_ent_set_behave(handle,"rotate");
fr_ent_give_name(handle,"glass");

// Label the glass box
function glasslabel(me)
{
	local them = fr_ent_get_by_name("glass");
	local pos = fr_ent_get_position(them);
	local scr = fr_math_to_screen(pos);
	if(scr[2] > 0.0)
	{
		local dx = scr[0]-fr_image_width("ieyf")/2;
		local dy = scr[1]-fr_image_height("ieyf")/2;
		fr_draw_image_simple("ieyf",dx,dy);
	}
}
handle = fr_ent_create();
fr_ent_morph_draw(handle,DRAW_TOP);
fr_ent_set_behave(handle,"glasslabel");

// Make slate box
handle = fr_ent_create();
fr_ent_morph_mesh(handle,"slate","#cube");
fr_ent_set_position(handle,[0.0,-6.5,4.0]);
fr_ent_set_behave(handle,"rotate");

// Make pan cube
handle = fr_ent_create();
fr_ent_morph_mesh(handle,"brick","#cube");
fr_ent_set_scale(handle,0.5,1);
fr_ent_set_position(handle,[-2.0,-4.0,2.5]);
fr_ent_set_behave(handle,"pan");

// Make roll cube
handle = fr_ent_create();
fr_ent_morph_mesh(handle,"brick","#cube");
fr_ent_set_scale(handle,0.5,1);
fr_ent_set_position(handle,[0.0,-4.0,0.0]);
fr_ent_set_behave(handle,"roll");

// These ones don't do anything
handle = fr_ent_create();
fr_ent_morph_mesh(handle,"brick","#cube");
fr_ent_set_scale(handle,0.5,1);
fr_ent_set_position(handle,[-2.0,-2.0,-0.5]);
handle = fr_ent_create();
fr_ent_morph_mesh(handle,"brick","#cube");
fr_ent_set_scale(handle,0.5,1);
fr_ent_set_position(handle,[2.0,-2.0,-0.5]);

// Die model
handle = fr_ent_create();
fr_ent_morph_mesh(handle,"die12","die12");
fr_ent_set_position(handle,[1.0,6.0,0.0]);
fr_ent_set_behave(handle,"tumble");

// Sprites
handle = fr_ent_create();
fr_ent_morph_sprite(handle,"die6",0);
fr_ent_set_position(handle,[0.0,-2.0,0.0]);
fr_ent_set_behave(handle,"pan");
handle = fr_ent_create();
fr_ent_morph_sprite(handle,"die6",0);
fr_ent_set_position(handle,[-3.0,3.0,-0.5]);

// Billboard Sprites
handle = fr_ent_create();
fr_ent_morph_sprite(handle,"test",1);
fr_ent_set_position(handle,[-4.0,-4.0,-1.0]);
fr_ent_set_orientation(handle,[20.0,0.0,0.0]);
handle = fr_ent_create();
fr_ent_morph_sprite(handle,"test",1);
fr_ent_set_position(handle,[4.0,4.0,-1.0]);
fr_ent_set_orientation(handle,[225.0,0.0,0.0]);

// And of course, a sphere
handle = fr_ent_create();
fr_ent_morph_sphere(handle,"glassbead");
fr_ent_set_position(handle,[-4.0,-5.0,1.0]);
// fr_ent_set_behave(handle,"slowtate");
// fr_ent_set_color(handle,[1,0.4,0.4]);
handle = fr_ent_create();
fr_ent_morph_sphere(handle,"mirror");
fr_ent_set_position(handle,[-1.5,-5.0,0.5]);
fr_ent_set_scale(handle,1.5,0);
fr_ent_set_color(handle,[0.9,0.6,0.9]);

// Envmap sphere
handle = fr_ent_create();
fr_ent_morph_sphere(handle,"clouds");
fr_ent_set_position(handle,[-6.0,0.0,1.0]);
fr_ent_set_invert(handle,1);
fr_ent_set_scale(handle,2.0,0);

// Lights
handle = fr_ent_create();
fr_ent_morph_light(handle,LIGHT_OMNI,LIGHT_LINEAR,0.0,16.0);
fr_ent_set_position(handle,[0.0,-7.0,2.0]);
fr_ent_set_color(handle,[0.3,0.7,1.0]);
handle = fr_ent_create();
fr_ent_morph_light(handle,LIGHT_OMNI,LIGHT_LINEAR,0.0,16.0);
fr_ent_set_position(handle,[0.0,7.0,2.0]);
fr_ent_set_color(handle,[1.0,0.4,0.1]);

// Sounds
fr_sound_play("energy",[0.0,-6.5,4.0],PLAY_LOOP,20.0,0.1,0.6);
fr_sound_play("drag",[-2.0,-4.0,2.5],PLAY_LOOP,20.0,0.2,0.5);
fr_sound_play("drag",[0.0,-4.0,0.0],PLAY_LOOP,20.0,0.2,0.7);
fr_sound_play("chimes",[3.0,-4.5,1.0],PLAY_LOOP,20.0,0.4,1.0);
